Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 775545 - dev-haskell/pandoc-citeproc: remove
Summary: dev-haskell/pandoc-citeproc: remove
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Gentoo's Haskell Language team
URL:
Whiteboard:
Keywords: PMASKED
Depends on: 766294
Blocks:
  Show dependency tree
 
Reported: 2021-03-12 03:27 UTC by wolfgang
Modified: 2022-07-22 22:21 UTC (History)
6 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description wolfgang 2021-03-12 03:27:08 UTC
Per upstream [1], this package has been deprecated. Keeping this around will prevent a newer pandoc-2.11 from being added, which will also block a newer rstudio.

[1]: https://hackage.haskell.org/package/pandoc-citeproc

Reproducible: Always
Comment 1 wolfgang 2021-05-03 15:16:24 UTC
Changing from "IN_PRGORESS" to "CONFIRMED" because although PR 19865 originally included this it was taken out.
Comment 2 Helmut Jarausch 2021-06-12 11:32:35 UTC
The recent sci-mathematics/rstudio--1.3.1093-r1
still depends on this package.

What can I do?
Thanks,
Helmut
Comment 3 wolfgang 2021-06-12 11:38:46 UTC
(In reply to Helmut Jarausch from comment #2)
> The recent sci-mathematics/rstudio--1.3.1093-r1
> still depends on this package.
> 
> What can I do?
> Thanks,
> Helmut

What issue are you running into?

pandoc-citeproc should still be available in ::Gentoo.

The recent rstudio change is simply a revision bump to fix some incompatibilities with newer boost library
Comment 4 Pacho Ramos gentoo-dev 2021-11-16 08:42:52 UTC
For example in Fedora they dropped the dependency some months ago:
https://src.fedoraproject.org/rpms/rstudio/c/513333d190526edf5a8049ae024283074a676622?branch=rawhide
Comment 5 segmentation fault 2022-02-09 07:37:19 UTC
I am generally against removing anything (I always say to myself "Well, yesterday it was important, today it's not?") - BUT: let me describe to you, just FYI, the kind of hell I'm having trying to upgrade haskell, pandoc & Co.:

Suppose you have rstudio installed, or you want to install it.

rstudio (the only available ebuild rstudio-1.3.1093-r1.ebuild) needs dev-haskell/pandoc-citeproc as a running dependency. So far so good. I cannot say if this is right or wrong.

dev-haskell/pandoc-citeproc (the only available ebuild pandoc-citeproc-0.17.0.2.ebuild) poses severe restrictions on its running dependency pandoc:

>=app-text/pandoc-2.8:=[profile?] <app-text/pandoc-2.11:=[profile?]

This means, that from the three available versions (all testing on amd64) of pandoc:

* app-text/pandoc
     Available versions:  (~)2.9.2.1:0/2.9.2.1^t (~)2.11.3.1:0/2.11.3.1^t (~)2.13:0/2.13^t {doc embed-data-files hscolour optimize profile static test trypandoc}

the *only one* that can be used is 2.9.2.1 (that's where the root of the problem lies).

Now, pandoc-2.9.2.1 requires <dev-haskell/hslua-1.1:=[profile?].

But the one and only available version of dev-haskell/hslua-module-path-0.1.0.1 requires >=dev-haskell/hslua-1.2:=[profile?].

So you can't install dev-haskell/hslua and dev-haskell/hslua-module-path together - but you must, because they go together.

Now what?

You can easily reproduce this by hard-unmerging the respective haskell packages, including app-text/pandoc (but you can leave rstudio, if it's installed, to save you the hassle of long compilation):

emerge -C dev-haskell/texmath dev-haskell/hslua-module-text dev-haskell/hslua-module-system dev-haskell/hslua-module-path dev-haskell/commonmark-pandoc dev-haskell/citeproc dev-haskell/pandoc-types dev-haskell/hslua dev-haskell/pandoc-citeproc app-text/pandoc

Now rstudio will be "broken" (theoretically) for a moment. But try to merge them again:

emerge -1Dav dev-haskell/texmath dev-haskell/hslua-module-text dev-haskell/hslua-module-system dev-haskell/hslua-module-path dev-haskell/commonmark-pandoc dev-haskell/citeproc dev-haskell/pandoc-types dev-haskell/hslua dev-haskell/pandoc-citeproc app-text/pandoc

Here is what I get:

These are the packages that would be merged, in reverse order:

Calculating dependencies... done!
[ebuild  N    ~] dev-haskell/pandoc-citeproc-0.17.0.2:0/0.17.0.2::gentoo  USE="bibutils -debug -doc -embed-data-files -hscolour -profile -static -test -unicode-collation" 0 KiB
[ebuild  N    ~] dev-haskell/citeproc-0.3.0.9:0/0.3.0.9::gentoo  USE="icu -doc -executable -hscolour -profile -test" 0 KiB
[ebuild  N    ~] dev-haskell/commonmark-pandoc-0.2.0.1:0/0.2.0.1::gentoo  USE="-doc -hscolour -profile" 0 KiB
[ebuild  N    ~] dev-haskell/hslua-module-path-0.1.0.1:0/0.1.0.1::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~] app-text/pandoc-2.9.2.1:0/2.9.2.1::gentoo  USE="-doc -embed-data-files -hscolour -optimize -profile -static -test -trypandoc" 0 KiB
[ebuild  N    ~]  dev-haskell/hslua-module-text-0.2.1:0/0.2.1::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~]  dev-haskell/texmath-0.12.2:0/0.12.2::gentoo  USE="network-uri -doc -executable -hscolour -profile -test" 0 KiB
[ebuild  N    ~] dev-haskell/pandoc-types-1.22:0/1.22::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~] dev-haskell/pandoc-types-1.20:0/1.20::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~] dev-haskell/hslua-1.3.0.1:0/1.3.0.1::gentoo  USE="-doc -hardcode-reg-keys -hscolour -profile -test" 0 KiB
[ebuild  N    ~] dev-haskell/hslua-module-system-0.2.2.1:0/0.2.2.1::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~]  dev-haskell/hslua-1.0.3.1:0/1.0.3.1::gentoo  USE="-doc -hscolour -profile -test" 0 KiB

Total: 12 packages (12 new), Size of downloads: 0 KiB

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

dev-haskell/pandoc-types:0

  (dev-haskell/pandoc-types-1.22:0/1.22::gentoo, ebuild scheduled for merge) USE="-doc -hscolour -profile -test" ABI_X86="(64)" pulled in by
    >=dev-haskell/pandoc-types-1.21:=[profile?] required by (dev-haskell/commonmark-pandoc-0.2.0.1:0/0.2.0.1::gentoo, ebuild scheduled for merge) USE="-doc -hscolour -profile" ABI_X86="(64)"
    ^^                         ^^^^                                                                                                                                                                                                                                                                                                                 
    >=dev-haskell/pandoc-types-1.22:=[profile?] required by (dev-haskell/citeproc-0.3.0.9:0/0.3.0.9::gentoo, ebuild scheduled for merge) USE="icu -doc -executable -hscolour -profile -test" ABI_X86="(64)"
    ^^                         ^^^^                                                                                                                                                                                                                                                                                                                                                                                       

  (dev-haskell/pandoc-types-1.20:0/1.20::gentoo, ebuild scheduled for merge) USE="-doc -hscolour -profile -test" ABI_X86="(64)" pulled in by
    <dev-haskell/pandoc-types-1.21:=[profile?] required by (app-text/pandoc-2.9.2.1:0/2.9.2.1::gentoo, ebuild scheduled for merge) USE="-doc -embed-data-files -hscolour -optimize -profile -static -test -trypandoc" ABI_X86="(64)"
    ^                         ^^^^ ^                                                                                                                                                                                                                                                                                                                                                                                                                                                     
    <dev-haskell/pandoc-types-1.22:=[profile?] required by (dev-haskell/pandoc-citeproc-0.17.0.2:0/0.17.0.2::gentoo, ebuild scheduled for merge) USE="bibutils -debug -doc -embed-data-files -hscolour -profile -static -test -unicode-collation" ABI_X86="(64)"
    ^                         ^^^^ ^                                                                                                                                                                                                                                                                                                                                                         
                                                                                                                                           

dev-haskell/hslua:0

  (dev-haskell/hslua-1.3.0.1:0/1.3.0.1::gentoo, ebuild scheduled for merge) USE="-doc -hardcode-reg-keys -hscolour -profile -test" ABI_X86="(64)" pulled in by
    >=dev-haskell/hslua-1.2:=[profile?] required by (dev-haskell/hslua-module-path-0.1.0.1:0/0.1.0.1::gentoo, ebuild scheduled for merge) USE="-doc -hscolour -profile -test" ABI_X86="(64)"
    ^^                  ^^^                                                                                                                                                                                                                                                                                                                                          

  (dev-haskell/hslua-1.0.3.1:0/1.0.3.1::gentoo, ebuild scheduled for merge) USE="-doc -hscolour -profile -test" ABI_X86="(64)" pulled in by
    <dev-haskell/hslua-1.2:=[profile?] required by (dev-haskell/hslua-module-text-0.2.1:0/0.2.1::gentoo, ebuild scheduled for merge) USE="-doc -hscolour -profile -test" ABI_X86="(64)"
    ^                  ^^^ ^                                                                                                                                                                                                                                                                                                                                    
    <dev-haskell/hslua-1.1:=[profile?] required by (app-text/pandoc-2.9.2.1:0/2.9.2.1::gentoo, ebuild scheduled for merge) USE="-doc -embed-data-files -hscolour -optimize -profile -static -test -trypandoc" ABI_X86="(64)"
    ^                  ^^^ ^                                                                                                                                                                                                                                                                                                                                                                 

portage stops at this point and does not do anything (of course, what shall it do?). Now, the system is not "just a bit broken" - it's *really* broken because we also lost pandoc and various haskell packages...very frustrating!

This could probably be resolved by getting pandoc-citeproc to work with higher versions of pandoc (higher than 2.9.2.1, e.g. the also available 2.11.3.1 or 2.13 versions), but I don't know if this is possible at all of if Gentoo can do anything about it...

From a user perspective, I ask myself "is pandoc-citeproc really *needed* to run rstudio?". That is, do I need a package for citations to do statistics? I may need it if I do statistics, want to write a paper with Rmarkdown *and* want to cite someone - then, maybe yes. So this could be possibly alleviated with the introduction of a "citeproc" USE flag: pandoc-citeproc would be pulled-in only if that USE flag were present.

One of the above two solutions is probably needed, otherwise the dependencies are unsolvable.
Comment 6 segmentation fault 2022-02-09 07:53:57 UTC
I already have rstudio installed - I don't know how I managed, possibly by not using --deep when I merged it. I tried the second solution above and just took the dependency on pandoc-citeproc away from rstudio's ebuild (just deleted the line).

Retrying to merge the packages (without asking explicitly for pandoc-citeproc this time) with

emerge -1Dav dev-haskell/texmath dev-haskell/hslua-module-text dev-haskell/hslua-module-system dev-haskell/hslua-module-path dev-haskell/commonmark-pandoc dev-haskell/citeproc dev-haskell/pandoc-types dev-haskell/hslua app-text/pandoc

results in a very acceptable offer (you see that the only thing that was keeping pandoc from being bumped to 2.13 was pandoc-citeproc!). This even frees the way to upgrade some other packages. It looks very good to me:

[ebuild  N    ~] app-text/pandoc-2.13:0/2.13::gentoo  USE="-doc -embed-data-files -hscolour -optimize -profile -test -trypandoc" 0 KiB
[ebuild  N    ~]  dev-haskell/citeproc-0.3.0.9:0/0.3.0.9::gentoo  USE="icu -doc -executable -hscolour -profile -test" 0 KiB
[ebuild  N    ~]  dev-haskell/commonmark-pandoc-0.2.0.1:0/0.2.0.1::gentoo  USE="-doc -hscolour -profile" 0 KiB
[ebuild  N    ~]  dev-haskell/texmath-0.12.2:0/0.12.2::gentoo  USE="network-uri -doc -executable -hscolour -profile -test" 0 KiB
[ebuild  N    ~]   dev-haskell/pandoc-types-1.22:0/1.22::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild     U ~]  dev-haskell/skylighting-0.10.5-r1:0/0.10.5::gentoo [0.8.5-r1:0/0.8.5::gentoo] USE="-doc -executable -hscolour -profile" 0 KiB
[ebuild     U ~]  dev-haskell/doctemplates-0.9:0/0.9::gentoo [0.8.2:0/0.8.2::gentoo] USE="-doc -hscolour -profile -test" 0 KiB
[ebuild     U ~]  dev-haskell/skylighting-core-0.10.5-r1:0/0.10.5::gentoo [0.8.5-r1:0/0.8.5::gentoo] USE="-doc -executable -hscolour -profile -test" 0 KiB
[ebuild     U ~]  dev-haskell/jira-wiki-markup-1.3.4:0/1.3.4::gentoo [1.1.4:0/1.1.4::gentoo] USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~]  dev-haskell/hslua-module-path-0.1.0.1:0/0.1.0.1::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~]  dev-haskell/hslua-module-system-0.2.2.1:0/0.2.2.1::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~]  dev-haskell/hslua-module-text-0.3.0.1:0/0.3.0.1::gentoo  USE="-doc -hscolour -profile -test" 0 KiB
[ebuild  N    ~]   dev-haskell/hslua-1.3.0.1:0/1.3.0.1::gentoo  USE="-doc -hardcode-reg-keys -hscolour -profile -test" 0 KiB

Total: 13 packages (4 upgrades, 9 new), Size of downloads: 0 KiB

so I'm going to accept and see if rstudio runs or not afterwards.
Comment 7 segmentation fault 2022-02-09 08:31:00 UTC
rstudio runs after the above. I guess the only restriction is that I cannot cite papers in Rmarkdown now, since pandoc-citeproc is not installed...
Comment 8 Larry the Git Cow gentoo-dev 2022-07-22 22:21:07 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=a9d5fc19de9f6ba9a6e9982f61f2c7518f058de1

commit a9d5fc19de9f6ba9a6e9982f61f2c7518f058de1
Author:     Sam James <sam@gentoo.org>
AuthorDate: 2022-07-22 22:20:47 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2022-07-22 22:20:47 +0000

    profiles: last-rite sci-mathematics/rstudio, dev-haskell/pandoc-citeproc
    
    Bug: https://bugs.gentoo.org/766294
    Bug: https://bugs.gentoo.org/775545
    Bug: https://bugs.gentoo.org/855197
    Bug: https://bugs.gentoo.org/727912
    Bug: https://bugs.gentoo.org/831868
    Bug: https://bugs.gentoo.org/696938
    Bug: https://bugs.gentoo.org/531996
    Bug: https://bugs.gentoo.org/836111
    Bug: https://bugs.gentoo.org/818721
    Signed-off-by: Sam James <sam@gentoo.org>

 profiles/package.mask | 7 +++++++
 1 file changed, 7 insertions(+)